
#line 1 "../../../src/main/http_request_parser.rl"

#include <lighttpd/base.h>
#include <lighttpd/http_request_parser.h>
#include <lighttpd/lighttpd-glue.h>

/** Machine **/

#define _getString(M, FPC) (li_chunk_extract(ctx->M, LI_GETMARK(FPC), NULL))
#define getString(FPC) _getString(mark, FPC)

#define _getStringTo(M, FPC, s) (li_chunk_extract_to(ctx->M, LI_GETMARK(FPC), s, NULL))
#define getStringTo(FPC, s) _getStringTo(mark, FPC, s)



#line 109 "../../../src/main/http_request_parser.rl"



#line 23 "http_request_parser.c"
static const unsigned char _li_http_request_parser_key_offsets[] = {
	0, 0, 16, 31, 34, 38, 39, 40, 
	41, 42, 43, 46, 49, 51, 55, 71, 
	86, 94, 102, 120, 121, 122, 131, 133, 
	134, 136, 137, 140, 144, 148, 152, 153
};

static const char _li_http_request_parser_trans_keys[] = {
	10, 13, 34, 44, 47, 123, 125, 127, 
	0, 32, 40, 41, 58, 64, 91, 93, 
	32, 34, 44, 47, 123, 125, 127, 0, 
	31, 40, 41, 58, 64, 91, 93, 127, 
	0, 32, 32, 127, 0, 31, 72, 84, 
	84, 80, 47, 49, 48, 57, 46, 48, 
	57, 48, 57, 10, 13, 48, 57, 10, 
	13, 34, 44, 47, 123, 125, 127, 0, 
	32, 40, 41, 58, 64, 91, 93, 34, 
	44, 47, 58, 123, 125, 127, 0, 32, 
	40, 41, 59, 64, 91, 93, 9, 10, 
	13, 32, 34, 127, 0, 31, 10, 13, 
	34, 127, 0, 8, 11, 31, 9, 10, 
	13, 32, 34, 44, 47, 123, 125, 127, 
	0, 31, 40, 41, 58, 64, 91, 93, 
	10, 10, 10, 13, 34, 92, 127, 0, 
	8, 11, 31, 9, 32, 10, 32, 126, 
	10, 46, 48, 57, 48, 49, 50, 57, 
	10, 13, 48, 57, 10, 13, 48, 57, 
	10, 0
};

static const char _li_http_request_parser_single_lengths[] = {
	0, 8, 7, 1, 2, 1, 1, 1, 
	1, 1, 1, 1, 0, 2, 8, 7, 
	6, 4, 10, 1, 1, 5, 2, 1, 
	0, 1, 1, 2, 2, 2, 1, 0
};

static const char _li_http_request_parser_range_lengths[] = {
	0, 4, 4, 1, 1, 0, 0, 0, 
	0, 0, 1, 1, 1, 1, 4, 4, 
	1, 2, 4, 0, 0, 2, 0, 0, 
	1, 0, 1, 1, 1, 1, 0, 0
};

static const unsigned char _li_http_request_parser_index_offsets[] = {
	0, 0, 13, 25, 28, 32, 34, 36, 
	38, 40, 42, 45, 48, 50, 54, 67, 
	79, 87, 94, 109, 111, 113, 121, 124, 
	126, 128, 130, 133, 137, 141, 145, 147
};

static const char _li_http_request_parser_indicies[] = {
	1, 3, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 0, 5, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	4, 2, 2, 6, 8, 2, 2, 7, 
	9, 2, 10, 2, 11, 2, 12, 2, 
	13, 2, 15, 14, 2, 16, 14, 2, 
	17, 2, 18, 19, 17, 2, 21, 22, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 2, 20, 2, 2, 2, 24, 2, 
	2, 2, 2, 2, 2, 2, 23, 26, 
	27, 28, 26, 29, 2, 2, 25, 31, 
	32, 33, 2, 2, 2, 30, 30, 35, 
	36, 30, 2, 2, 2, 2, 2, 2, 
	2, 2, 2, 2, 34, 21, 2, 31, 
	2, 37, 38, 30, 39, 2, 2, 2, 
	33, 33, 33, 2, 37, 2, 33, 2, 
	18, 2, 40, 14, 2, 41, 42, 17, 
	2, 43, 44, 17, 2, 45, 46, 17, 
	2, 1, 2, 2, 0
};

static const char _li_http_request_parser_trans_targs[] = {
	2, 1, 0, 30, 2, 3, 4, 4, 
	5, 6, 7, 8, 9, 10, 11, 26, 
	12, 13, 14, 25, 15, 31, 19, 15, 
	16, 17, 16, 18, 20, 21, 17, 18, 
	20, 21, 15, 31, 19, 22, 23, 24, 
	27, 28, 29, 14, 25, 14, 25
};

static const char _li_http_request_parser_trans_actions[] = {
	1, 0, 0, 0, 0, 2, 3, 0, 
	4, 5, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 3, 6, 0, 0, 
	7, 3, 0, 3, 3, 3, 0, 0, 
	0, 0, 8, 9, 10, 0, 0, 0, 
	0, 0, 0, 11, 11, 12, 12
};

static const int li_http_request_parser_start = 1;
static const int li_http_request_parser_first_final = 31;
static const int li_http_request_parser_error = 0;

static const int li_http_request_parser_en_main = 1;


#line 112 "../../../src/main/http_request_parser.rl"

static int li_http_request_parser_has_error(liHttpRequestCtx *ctx) {
	return ctx->chunk_ctx.cs == li_http_request_parser_error;
}

static int li_http_request_parser_is_finished(liHttpRequestCtx *ctx) {
	return ctx->chunk_ctx.cs >= li_http_request_parser_first_final;
}

void li_http_request_parser_init(liHttpRequestCtx* ctx, liRequest *req, liChunkQueue *cq) {
	li_chunk_parser_init(&ctx->chunk_ctx, cq);
	ctx->request = req;
	ctx->h_key = g_string_sized_new(0);
	ctx->h_value = g_string_sized_new(0);

	
#line 139 "http_request_parser.c"
	{
	( ctx->chunk_ctx.cs) = li_http_request_parser_start;
	}

#line 128 "../../../src/main/http_request_parser.rl"
}

void li_http_request_parser_reset(liHttpRequestCtx* ctx) {
	li_chunk_parser_reset(&ctx->chunk_ctx);
	g_string_truncate(ctx->h_key, 0);
	g_string_truncate(ctx->h_value, 0);

	
#line 153 "http_request_parser.c"
	{
	( ctx->chunk_ctx.cs) = li_http_request_parser_start;
	}

#line 136 "../../../src/main/http_request_parser.rl"
}

void li_http_request_parser_clear(liHttpRequestCtx *ctx) {
	g_string_free(ctx->h_key, TRUE);
	g_string_free(ctx->h_value, TRUE);
}

liHandlerResult li_http_request_parse(liVRequest *vr, liHttpRequestCtx *ctx) {
	liHandlerResult res;

	if (li_http_request_parser_is_finished(ctx)) return LI_HANDLER_GO_ON;

	if (LI_HANDLER_GO_ON != (res = li_chunk_parser_prepare(&ctx->chunk_ctx))) return res;

	while (!li_http_request_parser_has_error(ctx) && !li_http_request_parser_is_finished(ctx)) {
		char *p, *pe;
		GError *err = NULL;

		if (LI_HANDLER_GO_ON != (res = li_chunk_parser_next(&ctx->chunk_ctx, &p, &pe, &err))) {
			if (NULL != err) {
				VR_ERROR(vr, "%s", err->message);
				g_error_free(err);
			}
			return res;
		}

		
#line 186 "http_request_parser.c"
	{
	int _klen;
	const char *_keys;
	int _trans;

	if ( p == pe )
		goto _test_eof;
	if ( ( ctx->chunk_ctx.cs) == 0 )
		goto _out;
_resume:
	_keys = _li_http_request_parser_trans_keys + _li_http_request_parser_key_offsets[( ctx->chunk_ctx.cs)];
	_trans = _li_http_request_parser_index_offsets[( ctx->chunk_ctx.cs)];

	_klen = _li_http_request_parser_single_lengths[( ctx->chunk_ctx.cs)];
	if ( _klen > 0 ) {
		const char *_lower = _keys;
		const char *_mid;
		const char *_upper = _keys + _klen - 1;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + ((_upper-_lower) >> 1);
			if ( (*p) < *_mid )
				_upper = _mid - 1;
			else if ( (*p) > *_mid )
				_lower = _mid + 1;
			else {
				_trans += (unsigned int)(_mid - _keys);
				goto _match;
			}
		}
		_keys += _klen;
		_trans += _klen;
	}

	_klen = _li_http_request_parser_range_lengths[( ctx->chunk_ctx.cs)];
	if ( _klen > 0 ) {
		const char *_lower = _keys;
		const char *_mid;
		const char *_upper = _keys + (_klen<<1) - 2;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + (((_upper-_lower) >> 1) & ~1);
			if ( (*p) < _mid[0] )
				_upper = _mid - 2;
			else if ( (*p) > _mid[1] )
				_lower = _mid + 2;
			else {
				_trans += (unsigned int)((_mid - _keys)>>1);
				goto _match;
			}
		}
		_trans += _klen;
	}

_match:
	_trans = _li_http_request_parser_indicies[_trans];
	( ctx->chunk_ctx.cs) = _li_http_request_parser_trans_targs[_trans];

	if ( _li_http_request_parser_trans_actions[_trans] == 0 )
		goto _again;

	switch ( _li_http_request_parser_trans_actions[_trans] ) {
	case 3:
#line 20 "../../../src/main/http_request_parser.rl"
	{ ctx->mark = LI_GETMARK(p); }
	break;
	case 6:
#line 21 "../../../src/main/http_request_parser.rl"
	{ {p++; goto _out; } }
	break;
	case 2:
#line 23 "../../../src/main/http_request_parser.rl"
	{
		getStringTo(p, ctx->request->http_method_str);
		ctx->request->http_method = li_http_method_from_string(GSTR_LEN(ctx->request->http_method_str));
	}
	break;
	case 4:
#line 27 "../../../src/main/http_request_parser.rl"
	{ getStringTo(p, ctx->request->uri.raw); }
	break;
	case 7:
#line 29 "../../../src/main/http_request_parser.rl"
	{
		getStringTo(p, ctx->h_key);
		li_g_string_clear(ctx->h_value);
	}
	break;
	case 11:
#line 82 "../../../src/main/http_request_parser.rl"
	{ ctx->request->http_version = LI_HTTP_VERSION_1_0; }
	break;
	case 12:
#line 83 "../../../src/main/http_request_parser.rl"
	{ ctx->request->http_version = LI_HTTP_VERSION_1_1; }
	break;
	case 5:
#line 84 "../../../src/main/http_request_parser.rl"
	{ ctx->request->http_version = LI_HTTP_VERSION_UNSET; }
	break;
	case 1:
#line 20 "../../../src/main/http_request_parser.rl"
	{ ctx->mark = LI_GETMARK(p); }
#line 98 "../../../src/main/http_request_parser.rl"
	{ ctx->request->http_method = LI_HTTP_METHOD_UNSET; }
	break;
	case 10:
#line 33 "../../../src/main/http_request_parser.rl"
	{
		getStringTo(p, ctx->h_value);
		/* Remove CRLF */
		if (ctx->h_value->len > 2) {
			ctx->h_value->len -= 2;
			ctx->h_value->str[ctx->h_value->len] = '\0';
			/* g_string_truncate(ctx->h_value, ctx->h_value->len - 2); */
		} else {
			li_g_string_clear(ctx->h_value);
		}
	}
#line 44 "../../../src/main/http_request_parser.rl"
	{
		li_http_header_insert(ctx->request->headers, GSTR_LEN(ctx->h_key), GSTR_LEN(ctx->h_value));
	}
	break;
	case 8:
#line 33 "../../../src/main/http_request_parser.rl"
	{
		getStringTo(p, ctx->h_value);
		/* Remove CRLF */
		if (ctx->h_value->len > 2) {
			ctx->h_value->len -= 2;
			ctx->h_value->str[ctx->h_value->len] = '\0';
			/* g_string_truncate(ctx->h_value, ctx->h_value->len - 2); */
		} else {
			li_g_string_clear(ctx->h_value);
		}
	}
#line 44 "../../../src/main/http_request_parser.rl"
	{
		li_http_header_insert(ctx->request->headers, GSTR_LEN(ctx->h_key), GSTR_LEN(ctx->h_value));
	}
#line 20 "../../../src/main/http_request_parser.rl"
	{ ctx->mark = LI_GETMARK(p); }
	break;
	case 9:
#line 33 "../../../src/main/http_request_parser.rl"
	{
		getStringTo(p, ctx->h_value);
		/* Remove CRLF */
		if (ctx->h_value->len > 2) {
			ctx->h_value->len -= 2;
			ctx->h_value->str[ctx->h_value->len] = '\0';
			/* g_string_truncate(ctx->h_value, ctx->h_value->len - 2); */
		} else {
			li_g_string_clear(ctx->h_value);
		}
	}
#line 44 "../../../src/main/http_request_parser.rl"
	{
		li_http_header_insert(ctx->request->headers, GSTR_LEN(ctx->h_key), GSTR_LEN(ctx->h_value));
	}
#line 21 "../../../src/main/http_request_parser.rl"
	{ {p++; goto _out; } }
	break;
#line 355 "http_request_parser.c"
	}

_again:
	if ( ( ctx->chunk_ctx.cs) == 0 )
		goto _out;
	if ( ++p != pe )
		goto _resume;
	_test_eof: {}
	_out: {}
	}

#line 163 "../../../src/main/http_request_parser.rl"

		li_chunk_parser_done(&ctx->chunk_ctx, p - ctx->chunk_ctx.buf);
	}

	if (li_http_request_parser_has_error(ctx)) return LI_HANDLER_ERROR;
	if (li_http_request_parser_is_finished(ctx)) {
		/* sanity check: if the whole http request header is larger than 64kbytes, then something probably went wrong */
		if (ctx->chunk_ctx.bytes_in > 64*1024) {
			VR_INFO(vr,
				"request header too large. limit: 64kb, received: %s",
				li_counter_format((guint64)ctx->chunk_ctx.bytes_in, COUNTER_BYTES, vr->wrk->tmp_str)->str
			);

			vr->response.http_status = 413; /* Request Entity Too Large */
			return LI_HANDLER_ERROR;
		}

		li_chunkqueue_skip(ctx->chunk_ctx.cq, ctx->chunk_ctx.bytes_in);
		return LI_HANDLER_GO_ON;
	}
	return LI_HANDLER_ERROR;
}
