
#line 1 "../../../src/main/http_response_parser.rl"

#include <lighttpd/base.h>
#include <lighttpd/http_response_parser.h>

/** Machine **/



#define _getString(M, FPC) (li_chunk_extract(ctx->M, LI_GETMARK(FPC), NULL))
#define getString(FPC) _getString(mark, FPC)

#define _getStringTo(M, FPC, s) (li_chunk_extract_to(ctx->M, LI_GETMARK(FPC), s, NULL))
#define getStringTo(FPC, s) _getStringTo(mark, FPC, s)



#line 107 "../../../src/main/http_response_parser.rl"



#line 24 "http_response_parser.c"
static const unsigned char _li_http_response_parser_key_offsets[] = {
	0, 0, 17, 32, 40, 48, 66, 67, 
	68, 77, 79, 80, 82, 98, 114, 130, 
	145, 147, 150, 152, 155, 157, 159, 161, 
	162, 167, 183, 184
};

static const char _li_http_response_parser_trans_keys[] = {
	10, 13, 34, 44, 47, 72, 123, 125, 
	127, 0, 32, 40, 41, 58, 64, 91, 
	93, 34, 44, 47, 58, 123, 125, 127, 
	0, 32, 40, 41, 59, 64, 91, 93, 
	9, 10, 13, 32, 34, 127, 0, 31, 
	10, 13, 34, 127, 0, 8, 11, 31, 
	9, 10, 13, 32, 34, 44, 47, 123, 
	125, 127, 0, 31, 40, 41, 58, 64, 
	91, 93, 10, 10, 10, 13, 34, 92, 
	127, 0, 8, 11, 31, 9, 32, 10, 
	32, 126, 34, 44, 47, 58, 84, 123, 
	125, 127, 0, 32, 40, 41, 59, 64, 
	91, 93, 34, 44, 47, 58, 84, 123, 
	125, 127, 0, 32, 40, 41, 59, 64, 
	91, 93, 34, 44, 47, 58, 80, 123, 
	125, 127, 0, 32, 40, 41, 59, 64, 
	91, 93, 34, 44, 47, 58, 123, 125, 
	127, 0, 32, 40, 41, 59, 64, 91, 
	93, 48, 57, 46, 48, 57, 48, 57, 
	32, 48, 57, 48, 57, 48, 57, 48, 
	57, 32, 10, 13, 127, 0, 31, 10, 
	13, 34, 44, 47, 123, 125, 127, 0, 
	32, 40, 41, 58, 64, 91, 93, 10, 
	0
};

static const char _li_http_response_parser_single_lengths[] = {
	0, 9, 7, 6, 4, 10, 1, 1, 
	5, 2, 1, 0, 8, 8, 8, 7, 
	0, 1, 0, 1, 0, 0, 0, 1, 
	3, 8, 1, 0
};

static const char _li_http_response_parser_range_lengths[] = {
	0, 4, 4, 1, 2, 4, 0, 0, 
	2, 0, 0, 1, 4, 4, 4, 4, 
	1, 1, 1, 1, 1, 1, 1, 0, 
	1, 4, 0, 0
};

static const unsigned char _li_http_response_parser_index_offsets[] = {
	0, 0, 14, 26, 34, 41, 56, 58, 
	60, 68, 71, 73, 75, 88, 101, 114, 
	126, 128, 131, 133, 136, 138, 140, 142, 
	144, 149, 162, 164
};

static const char _li_http_response_parser_indicies[] = {
	1, 3, 2, 2, 2, 4, 2, 2, 
	2, 2, 2, 2, 2, 0, 2, 2, 
	2, 6, 2, 2, 2, 2, 2, 2, 
	2, 5, 8, 9, 10, 8, 11, 2, 
	2, 7, 13, 14, 15, 2, 2, 2, 
	12, 12, 17, 18, 12, 2, 2, 2, 
	2, 2, 2, 2, 2, 2, 2, 16, 
	1, 2, 13, 2, 19, 20, 12, 21, 
	2, 2, 2, 15, 15, 15, 2, 19, 
	2, 15, 2, 2, 2, 2, 6, 22, 
	2, 2, 2, 2, 2, 2, 2, 5, 
	2, 2, 2, 6, 23, 2, 2, 2, 
	2, 2, 2, 2, 5, 2, 2, 2, 
	6, 24, 2, 2, 2, 2, 2, 2, 
	2, 5, 2, 2, 25, 6, 2, 2, 
	2, 2, 2, 2, 2, 5, 26, 2, 
	27, 26, 2, 28, 2, 29, 28, 2, 
	30, 2, 31, 2, 32, 2, 33, 2, 
	35, 36, 2, 2, 34, 1, 3, 2, 
	2, 2, 2, 2, 2, 2, 2, 2, 
	2, 0, 35, 2, 2, 0
};

static const char _li_http_response_parser_trans_targs[] = {
	2, 27, 0, 6, 12, 2, 3, 4, 
	3, 5, 7, 8, 4, 5, 7, 8, 
	2, 27, 6, 9, 10, 11, 13, 14, 
	15, 16, 17, 18, 19, 20, 21, 22, 
	23, 24, 24, 25, 26
};

static const char _li_http_response_parser_trans_actions[] = {
	1, 2, 0, 0, 1, 0, 3, 1, 
	0, 1, 1, 1, 0, 0, 0, 0, 
	4, 5, 6, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 1, 0, 
	0, 7, 0, 0, 0
};

static const int li_http_response_parser_start = 1;
static const int li_http_response_parser_first_final = 27;
static const int li_http_response_parser_error = 0;

static const int li_http_response_parser_en_main = 1;


#line 110 "../../../src/main/http_response_parser.rl"

static int li_http_response_parser_has_error(liHttpResponseCtx *ctx) {
	return ctx->chunk_ctx.cs == li_http_response_parser_error;
}

static int li_http_response_parser_is_finished(liHttpResponseCtx *ctx) {
	return ctx->chunk_ctx.cs >= li_http_response_parser_first_final;
}

void li_http_response_parser_init(liHttpResponseCtx* ctx, liResponse *req, liChunkQueue *cq, gboolean accept_cgi, gboolean accept_nph) {
	li_chunk_parser_init(&ctx->chunk_ctx, cq);
	ctx->response = req;
	ctx->accept_cgi = accept_cgi;
	ctx->accept_nph = accept_nph;
	ctx->drop_header = FALSE;
	ctx->h_key = g_string_sized_new(0);
	ctx->h_value = g_string_sized_new(0);

	
#line 147 "http_response_parser.c"
	{
	( ctx->chunk_ctx.cs) = li_http_response_parser_start;
	}

#line 129 "../../../src/main/http_response_parser.rl"
}

void li_http_response_parser_reset(liHttpResponseCtx* ctx) {
	li_chunk_parser_reset(&ctx->chunk_ctx);
	g_string_truncate(ctx->h_key, 0);
	g_string_truncate(ctx->h_value, 0);
	ctx->drop_header = FALSE;

	
#line 162 "http_response_parser.c"
	{
	( ctx->chunk_ctx.cs) = li_http_response_parser_start;
	}

#line 138 "../../../src/main/http_response_parser.rl"
}

void li_http_response_parser_clear(liHttpResponseCtx *ctx) {
	g_string_free(ctx->h_key, TRUE);
	g_string_free(ctx->h_value, TRUE);
}

static gboolean li_http_response_handle_finished(liHttpResponseCtx *ctx) {
	if (!li_http_response_parser_is_finished(ctx)) return FALSE;

	li_chunkqueue_skip(ctx->chunk_ctx.cq, ctx->chunk_ctx.bytes_in);
	if (ctx->drop_header) {
		li_http_response_parser_reset(ctx);
		return FALSE;
	} else {
		if (ctx->response->http_status == 0) ctx->response->http_status = 200;
		return TRUE;
	}
}

liHandlerResult li_http_response_parse(liVRequest *vr, liHttpResponseCtx *ctx) {
	liHandlerResult res;

	if (li_http_response_handle_finished(ctx)) return LI_HANDLER_GO_ON;

	if (LI_HANDLER_GO_ON != (res = li_chunk_parser_prepare(&ctx->chunk_ctx))) return res;

	while (!li_http_response_parser_has_error(ctx)) {
		char *p, *pe;
		GError *err = NULL;

		if (LI_HANDLER_GO_ON != (res = li_chunk_parser_next(&ctx->chunk_ctx, &p, &pe, &err))) {
			if (NULL != err) {
				VR_ERROR(vr, "%s", err->message);
				g_error_free(err);
			}
			return res;
		}

		
#line 208 "http_response_parser.c"
	{
	int _klen;
	const char *_keys;
	int _trans;

	if ( p == pe )
		goto _test_eof;
	if ( ( ctx->chunk_ctx.cs) == 0 )
		goto _out;
_resume:
	_keys = _li_http_response_parser_trans_keys + _li_http_response_parser_key_offsets[( ctx->chunk_ctx.cs)];
	_trans = _li_http_response_parser_index_offsets[( ctx->chunk_ctx.cs)];

	_klen = _li_http_response_parser_single_lengths[( ctx->chunk_ctx.cs)];
	if ( _klen > 0 ) {
		const char *_lower = _keys;
		const char *_mid;
		const char *_upper = _keys + _klen - 1;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + ((_upper-_lower) >> 1);
			if ( (*p) < *_mid )
				_upper = _mid - 1;
			else if ( (*p) > *_mid )
				_lower = _mid + 1;
			else {
				_trans += (unsigned int)(_mid - _keys);
				goto _match;
			}
		}
		_keys += _klen;
		_trans += _klen;
	}

	_klen = _li_http_response_parser_range_lengths[( ctx->chunk_ctx.cs)];
	if ( _klen > 0 ) {
		const char *_lower = _keys;
		const char *_mid;
		const char *_upper = _keys + (_klen<<1) - 2;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + (((_upper-_lower) >> 1) & ~1);
			if ( (*p) < _mid[0] )
				_upper = _mid - 2;
			else if ( (*p) > _mid[1] )
				_lower = _mid + 2;
			else {
				_trans += (unsigned int)((_mid - _keys)>>1);
				goto _match;
			}
		}
		_trans += _klen;
	}

_match:
	_trans = _li_http_response_parser_indicies[_trans];
	( ctx->chunk_ctx.cs) = _li_http_response_parser_trans_targs[_trans];

	if ( _li_http_response_parser_trans_actions[_trans] == 0 )
		goto _again;

	switch ( _li_http_response_parser_trans_actions[_trans] ) {
	case 1:
#line 21 "../../../src/main/http_response_parser.rl"
	{ ctx->mark = LI_GETMARK(p); }
	break;
	case 2:
#line 22 "../../../src/main/http_response_parser.rl"
	{ {p++; goto _out; } }
	break;
	case 7:
#line 24 "../../../src/main/http_response_parser.rl"
	{
		getStringTo(p, ctx->h_value);
		ctx->response->http_status = atoi(ctx->h_value->str);
		if (ctx->response->http_status >= 100 && ctx->response->http_status < 200) {
			ctx->drop_header = TRUE;
		}
	}
	break;
	case 3:
#line 32 "../../../src/main/http_response_parser.rl"
	{
		getStringTo(p, ctx->h_key);
		g_string_truncate(ctx->h_value, 0);
	}
	break;
	case 6:
#line 36 "../../../src/main/http_response_parser.rl"
	{
		guint i;
		/* strip whitespace */
		getStringTo(p, ctx->h_value);
		for (i = ctx->h_value->len; i-- > 0; ) {
			switch (ctx->h_value->str[i]) {
			case '\r':
			case '\n':
			case ' ':
				continue;
			}
			break;
		}
		g_string_truncate(ctx->h_value, i+1);
	}
#line 51 "../../../src/main/http_response_parser.rl"
	{
		if (ctx->accept_cgi && li_strncase_equal(ctx->h_key, CONST_STR_LEN("Status"))) {
			ctx->response->http_status = atoi(ctx->h_value->str);
		} else if (!ctx->drop_header) {
			li_http_header_insert(ctx->response->headers, GSTR_LEN(ctx->h_key), GSTR_LEN(ctx->h_value));
		}
	}
	break;
	case 4:
#line 36 "../../../src/main/http_response_parser.rl"
	{
		guint i;
		/* strip whitespace */
		getStringTo(p, ctx->h_value);
		for (i = ctx->h_value->len; i-- > 0; ) {
			switch (ctx->h_value->str[i]) {
			case '\r':
			case '\n':
			case ' ':
				continue;
			}
			break;
		}
		g_string_truncate(ctx->h_value, i+1);
	}
#line 51 "../../../src/main/http_response_parser.rl"
	{
		if (ctx->accept_cgi && li_strncase_equal(ctx->h_key, CONST_STR_LEN("Status"))) {
			ctx->response->http_status = atoi(ctx->h_value->str);
		} else if (!ctx->drop_header) {
			li_http_header_insert(ctx->response->headers, GSTR_LEN(ctx->h_key), GSTR_LEN(ctx->h_value));
		}
	}
#line 21 "../../../src/main/http_response_parser.rl"
	{ ctx->mark = LI_GETMARK(p); }
	break;
	case 5:
#line 36 "../../../src/main/http_response_parser.rl"
	{
		guint i;
		/* strip whitespace */
		getStringTo(p, ctx->h_value);
		for (i = ctx->h_value->len; i-- > 0; ) {
			switch (ctx->h_value->str[i]) {
			case '\r':
			case '\n':
			case ' ':
				continue;
			}
			break;
		}
		g_string_truncate(ctx->h_value, i+1);
	}
#line 51 "../../../src/main/http_response_parser.rl"
	{
		if (ctx->accept_cgi && li_strncase_equal(ctx->h_key, CONST_STR_LEN("Status"))) {
			ctx->response->http_status = atoi(ctx->h_value->str);
		} else if (!ctx->drop_header) {
			li_http_header_insert(ctx->response->headers, GSTR_LEN(ctx->h_key), GSTR_LEN(ctx->h_value));
		}
	}
#line 22 "../../../src/main/http_response_parser.rl"
	{ {p++; goto _out; } }
	break;
#line 382 "http_response_parser.c"
	}

_again:
	if ( ( ctx->chunk_ctx.cs) == 0 )
		goto _out;
	if ( ++p != pe )
		goto _resume;
	_test_eof: {}
	_out: {}
	}

#line 178 "../../../src/main/http_response_parser.rl"

		li_chunk_parser_done(&ctx->chunk_ctx, p - ctx->chunk_ctx.buf);

		if (li_http_response_handle_finished(ctx)) return LI_HANDLER_GO_ON;
	}

	return LI_HANDLER_ERROR;
}
